diff -r df9e3cb79379 -r 1ccb99c08f27 libinterp/parse-tree/pt-jit.h
--- a/libinterp/parse-tree/pt-jit.h	Wed May 08 18:45:34 2019 -0700
+++ b/libinterp/parse-tree/pt-jit.h	Fri May 31 16:09:22 2019 -0500
@@ -34,6 +34,7 @@
 #include "jit-ir.h"
 #include "pt-walk.h"
 #include "symscope.h"
+#include "stack-frame.h"
 
 // octave_value_list is not (yet) in the octave namespace
 class octave_value_list;
@@ -47,8 +48,7 @@
   }
 
   // Convert from the parse tree (AST) to the low level Octave IR.
-  class
-  jit_convert : public tree_walker
+  class jit_convert : public tree_walker
   {
   public:
 
@@ -67,15 +67,30 @@
       return create_checked_impl (ret);
     }
 
-    jit_block_list& get_blocks (void) { return m_blocks; }
+    jit_block_list& get_blocks (void)
+    {
+      return m_blocks;
+    }
 
-    const type_bound_vector& get_bounds (void) const { return m_bounds; }
+    const type_bound_vector& get_bounds (void) const
+    {
+      return m_bounds;
+    }
 
-    jit_factory& get_factory (void) { return m_factory; }
+    jit_factory& get_factory (void)
+    {
+      return m_factory;
+    }
 
-    llvm::Function *get_function (void) const { return m_function; }
+    llvm::Function * get_function (void) const
+    {
+      return m_function;
+    }
 
-    const variable_map& get_variable_map (void) const { return m_vmap; }
+    const variable_map& get_variable_map (void) const
+    {
+      return m_vmap;
+    }
 
     void visit_anon_fcn_handle (tree_anon_fcn_handle&);
 
@@ -168,10 +183,9 @@
     std::vector<std::pair<std::string, bool>> m_arguments;
     type_bound_vector m_bounds;
 
-    bool m_converting_function;
+    stack_frame& m_frame;
 
-    // the scope of the function we are converting, or the current scope
-    symbol_scope m_scope;
+    bool m_converting_function;
 
     jit_factory m_factory;
 
@@ -196,7 +210,7 @@
 
     variable_map m_vmap;
 
-    void initialize (const symbol_scope& s);
+    void initialize ();
 
     jit_call * create_checked_impl (jit_call *ret);
 
@@ -216,26 +230,36 @@
     // The name of the next for loop iterator.  If inc is false, then the
     // iterator counter will not be incremented.
     std::string next_iterator (bool inc = true)
-    { return next_name ("#iter", m_iterator_count, inc); }
+    {
+      return next_name ("#iter", m_iterator_count, inc);
+    }
 
     std::string next_for_bounds (bool inc = true)
-    { return next_name ("#for_bounds", m_for_bounds_count, inc); }
+    {
+      return next_name ("#for_bounds", m_for_bounds_count, inc);
+    }
 
     std::string next_shortcircut_result (bool inc = true)
-    { return next_name ("#shortcircut_result", m_short_count, inc); }
+    {
+      return next_name ("#shortcircut_result", m_short_count, inc);
+    }
 
     std::string next_name (const char *prefix, size_t& count, bool inc);
 
-    jit_instruction * resolve (tree_index_expression& exp,
-                               jit_value *extra_arg = nullptr, bool lhs = false);
+    jit_instruction *resolve (tree_index_expression& exp,
+                              jit_value *extra_arg = nullptr,
+                              bool lhs = false);
+
+    jit_value *do_assign (tree_expression *exp, jit_value *rhs,
+                          bool artificial = false);
 
-    jit_value * do_assign (tree_expression *exp, jit_value *rhs,
-                           bool artificial = false);
+    jit_value *do_assign (const std::string& lhs, jit_value *rhs, bool print,
+                          bool artificial = false);
 
-    jit_value * do_assign (const std::string& lhs, jit_value *rhs, bool print,
-                           bool artificial = false);
-
-    jit_value * visit (tree *tee) { return visit (*tee); }
+    jit_value * visit (tree *tee)
+    {
+      return visit (*tee);
+    }
 
     jit_value * visit (tree& tee);
 
@@ -243,38 +267,39 @@
     block_list m_breaks;
     block_list m_continues;
 
-    void finish_breaks (jit_block *dest, const block_list& lst);
+    void finish_breaks (jit_block *dest, block_list& lst);
   };
 
   // Convert from the low level Octave IR to LLVM
-  class
-  jit_convert_llvm : public jit_ir_walker
+  class jit_convert_llvm : public jit_ir_walker
   {
   public:
+    jit_convert_llvm (const jit_module& amodule)
+        : m_module (amodule) { }
 
-    llvm::Function * convert_loop (const jit_module& module,
-                                   const jit_block_list& blocks,
-                                   const std::list<jit_value *>& constants,
-                                   const std::string& llvm_function_name);
+    llvm::Function * convert_loop (const jit_block_list& blocks,
+                                  const std::list<jit_value *>& constants,
+                                  const std::string& llvm_function_name);
 
-    jit_function convert_function (const jit_module& module,
-                                   const jit_block_list& blocks,
+    jit_function convert_function (const jit_block_list& blocks,
                                    const std::list<jit_value *>& constants,
                                    octave_user_function& fcn,
                                    const std::vector<jit_type *>& args);
 
     // arguments to the llvm::Function for loops
-    const std::vector<std::pair<std::string, bool>>& get_arguments(void) const
-    { return m_argument_vec; }
+    const std::vector<std::pair<std::string, bool>>& get_arguments (void) const
+    {
+      return m_argument_vec;
+    }
 
-#define JIT_METH(clname)                        \
-    virtual void visit (jit_ ## clname&);
+#define JIT_METH(clname) virtual void visit (jit_##clname&);
 
     JIT_VISIT_IR_CLASSES;
 
 #undef JIT_METH
 
   private:
+    const jit_module& m_module;
 
     // name -> argument index (used for compiling functions)
     std::map<std::string, int> m_argument_index;
@@ -302,6 +327,7 @@
       return visit (*jvalue);
     }
 
+    // Is this really necessary? It's only called by the above function.
     void visit (jit_value& jvalue)
     {
       jvalue.accept (*this);
@@ -309,24 +335,27 @@
   };
 
   // type inference and SSA construction on the low level Octave IR
-  class
-  jit_infer
+  class jit_infer
   {
   public:
-
     typedef jit_convert::variable_map variable_map;
 
     jit_infer (jit_factory& afactory, jit_block_list& ablocks,
                const variable_map& avmap);
 
-    jit_block_list& get_blocks (void) const { return m_blocks; }
+    jit_block_list& get_blocks (void) const
+    {
+      return m_blocks;
+    }
 
-    jit_factory& get_factory (void) const { return m_factory; }
+    jit_factory& get_factory (void) const
+    {
+      return m_factory;
+    }
 
     void infer (void);
 
   private:
-
     jit_block_list& m_blocks;
     jit_factory& m_factory;
     const variable_map& m_vmap;
@@ -340,9 +369,15 @@
 
     void do_construct_ssa (jit_block& block, size_t avisit_count);
 
-    jit_block& entry_block (void) { return *m_blocks.front (); }
+    jit_block& entry_block (void)
+    {
+      return *m_blocks.front ();
+    }
 
-    jit_block& final_block (void) { return *m_blocks.back (); }
+    jit_block& final_block (void)
+    {
+      return *m_blocks.back ();
+    }
 
     void place_releases (void);
 
@@ -359,42 +394,37 @@
     void simplify_phi (jit_phi& phi);
   };
 
-
   class jit_module;
 
-  class
-  tree_jit
+  class tree_jit
   {
     // ----- Constructor/destructor (singleton pattern) -----
 
   public:
-
     ~tree_jit (void);
 
   private:
-
     tree_jit (void);
     static tree_jit& instance (void);
 
     // ----- Initialization -----
 
   private:
-
     static bool initialized;
     bool do_initialize (void);
 
     // ----- LLVM context -----
 
   public:
-
     static llvm::LLVMContext llvm_context;
 
     // ----- Target machine ----
 
   public:
-
-    static const llvm::TargetMachine* get_target_machine (void)
-    { return instance ().target_machine; }
+    static const llvm::TargetMachine * get_target_machine (void)
+    {
+      return instance ().target_machine;
+    }
 
   private:
 
@@ -403,79 +433,77 @@
     // ----- Create LLVM modules and engines -----
 
   public:
+    static jit::ModuleOwner open_new_module (const std::string& module_name
+                                             = generate_unique_module_name ());
 
-    static jit::ModuleOwner
-    open_new_module (const std::string& module_name = generate_unique_module_name ());
-
-    static jit::EngineOwner
-    create_new_engine (jit::ModuleOwner module_owner);
+    static jit::EngineOwner create_new_engine (jit::ModuleOwner module_owner);
 
   private:
-
-    jit::ModuleOwner
-    do_open_new_module (const std::string& module_name) const;
+    jit::ModuleOwner do_open_new_module (const std::string& module_name) const;
 
     // ----- Registering JIT modules (module+engine pairs) -----
 
   public:
+    static void register_jit_module (jit_module *jm)
+    {
+      instance ().do_register_jit_module (jm);
+    }
 
-    static void register_jit_module (jit_module* jm)
-    { instance ().do_register_jit_module (jm); }
-
-    static void unregister_jit_module (jit_module* jm)
-    { instance ().do_unregister_jit_module (jm); }
+    static void unregister_jit_module (jit_module *jm)
+    {
+      instance ().do_unregister_jit_module (jm);
+    }
 
   private:
-
     // List of all currently registered jit modules
-    std::list<jit_module*> jm_list;
-    void do_register_jit_module (jit_module* jm);
-    void do_unregister_jit_module (jit_module* jm);
+    std::list<jit_module *> jm_list;
+    void do_register_jit_module (jit_module *jm);
+    void do_unregister_jit_module (jit_module *jm);
     void do_dump_all_modules (void) const;
 
     // ----- Symbol resolution -----
 
   public:
+    static void * getPointerToNamedFunction (const std::string& name)
+    {
+      return instance ().do_getPointerToNamedFunction (name);
+    }
 
-    static void* getPointerToNamedFunction (const std::string &name)
-    { return instance ().do_getPointerToNamedFunction (name); }
-
-    static uint64_t getSymbolAddress (const std::string &name)
-    { return instance ().do_getSymbolAddress (name); }
+    static uint64_t getSymbolAddress (const std::string& name)
+    {
+      return instance ().do_getSymbolAddress (name);
+    }
 
   private:
+    void *do_getPointerToNamedFunction (const std::string& Name) const;
 
-    void* do_getPointerToNamedFunction (const std::string &Name) const;
-
-    uint64_t do_getSymbolAddress (const std::string &name) const;
+    uint64_t do_getSymbolAddress (const std::string& name) const;
 
     // ----- Generate unique identifiers -----
 
   public:
-
     static std::string generate_unique_forloop_name (void)
     {
       return std::string ("jittedForLoop")
-             + std::to_string (next_forloop_number ++);
+             + std::to_string (next_forloop_number++);
     }
     // FIXME: Check that the identifier does not exist
 
     static std::string generate_unique_function_name (void)
     {
       return std::string ("jittedFunction")
-             + std::to_string (next_function_number ++);
+             + std::to_string (next_function_number++);
     }
     // FIXME: Check that the identifier does not exist
 
     static std::string generate_unique_module_name (void)
     {
       return std::string ("octaveJITModule")
-             + std::to_string (next_module_number ++);
+             + std::to_string (next_module_number++);
     }
     // FIXME: Check that the identifier does not exist
 
   private:
-
     static int next_forloop_number;
     static int next_function_number;
     static int next_module_number;
@@ -483,29 +511,31 @@
     // ----- JIT and execute ASTs -----
 
   public:
-
-    static bool execute (tree_simple_for_command& cmd,
-                         const octave_value& bounds)
-    { return instance ().do_execute (cmd, bounds); }
+    static bool execute (tree_evaluator& tr_eval, tree_simple_for_command& cmd,
+             const octave_value& bounds)
+    {
+      return instance ().do_execute (tr_eval, cmd, bounds);
+    }
 
-    static bool execute (tree_while_command& cmd)
-    { return instance ().do_execute (cmd); }
+    static bool execute (tree_evaluator& tr_eval, tree_while_command& cmd)
+    {
+      return instance ().do_execute (tr_eval, cmd);
+    }
 
-    static bool execute (octave_user_function& fcn,
-                         const octave_value_list& args,
-                         octave_value_list& retval)
-    { return instance ().do_execute (fcn, args, retval); }
+    static bool execute (tree_evaluator& tr_eval, octave_user_function& fcn,
+             const octave_value_list& args, octave_value_list& retval)
+    {
+      return instance ().do_execute (tr_eval, fcn, args, retval);
+    }
 
   private:
-
-    bool do_execute (tree_simple_for_command& cmd,
+    bool do_execute (tree_evaluator& tr_eval, tree_simple_for_command& cmd,
                      const octave_value& bounds);
 
-    bool do_execute (tree_while_command& cmd);
+    bool do_execute (tree_evaluator& tr_eval, tree_while_command& cmd);
 
-    bool do_execute (octave_user_function& fcn,
-                     const octave_value_list& args,
-                     octave_value_list& retval);
+    bool do_execute (tree_evaluator& tr_eval, octave_user_function& fcn,
+                     const octave_value_list& args, octave_value_list& retval);
 
     // ----- Miscellaneous -----
 
@@ -514,9 +544,7 @@
     size_t trip_count (const octave_value& bounds) const;
   };
 
-
-  class
-  jit_module
+  class jit_module
   {
     // TODO: Encapsulate all operations that can modify the module,
     //       and prevent them if the module has been finalized
@@ -525,7 +553,6 @@
     //       I have read somewhere that this is more efficient (nor sure)
 
   public:
-
     // Create an open module and associated JIT engine
     jit_module (const std::string& module_name
                 = tree_jit::generate_unique_module_name ());
@@ -534,34 +561,34 @@
     ~jit_module ();
 
     // Create an LLVM function in the module, with external linkage
-    llvm::Function*
-    create_llvm_function (llvm::FunctionType *ftype,
-                          const llvm::Twine &name) const;
+    llvm::Function * create_llvm_function (llvm::FunctionType *ftype,
+                                           const llvm::Twine& name) const;
 
     // Create a global in the module, with external linkage
-    llvm::GlobalVariable*
-    create_global_variable (llvm::Type *type, bool is_constant,
-                            const llvm::Twine& name) const;
+    llvm::GlobalVariable * create_global_variable (llvm::Type *type,
+                                                   bool is_constant,
+                                                 const llvm::Twine& name) const;
 
     // Create or insert an LLVM Function declaration for an intrinsic,
     // and return it
-    llvm::Function*
-    get_intrinsic_declaration (size_t id,
-                               std::vector<llvm::Type*> types) const;
+    llvm::Function * get_intrinsic_declaration (size_t id,
+                                  const std::vector<llvm::Type *>& types) const;
 
     // Underlying type of enums defined in yet-inconplete types
-    typedef unsigned llvm_gv_linkage;  // FIXME: autoconf this
+    typedef unsigned llvm_gv_linkage; // FIXME: autoconf this
 
     // add_global_mapping tells the execution engine where a specified
     // global value (variable or function) is
     template <typename ptr_type>
-    void add_global_mapping (const llvm::GlobalValue* gv, ptr_type p) const
+    void add_global_mapping (const llvm::GlobalValue *gv, ptr_type p) const
     {
       do_add_global_mapping (gv, reinterpret_cast<void *> (p));
     }
 
     // Return the address of the specified function.
-    uint64_t getFunctionAddress (const std::string &name) const;
+    uint64_t getFunctionAddress (const std::string& name) const;
+
+    llvm::Function * getFunction (const std::string& name) const;
 
     // Optimize a function in the LLVM module
     void optimize (llvm::Function *fn) const;
@@ -570,43 +597,54 @@
     // to change anything in the module...
     void finalizeObject (void);
 
-  private:
+    // Print a summary for the object. For stdout-based debugging.
+    void print_object_summary (void);
+
+    // Print all function locations. For stdout-based debugging.
+    void print_all_flocs (void) const;
 
-    void do_add_global_mapping (const llvm::GlobalValue* gv, void* p) const;
+    // Print the IR for all functions. For stdout-based debugging.
+    void print_all_functions (void) const;
+
+    // Dump a representation of the module.
+    void dump (void) const;
+
+  private:
+    void do_add_global_mapping (const llvm::GlobalValue *gv, void *p) const;
 
     llvm::Module *m_module;
     llvm::ExecutionEngine *m_engine;
   };
 
-
-  class
-  jit_info : public jit_module
+  class jit_info : public jit_module
   {
   public:
-
     // we use a pointer here so we don't have to include ov.h
     typedef std::map<std::string, const octave_value *> vmap;
 
-    jit_info (tree& tee);
+    jit_info (tree_evaluator& tr_eval, tree& tee);
 
-    jit_info (tree& tee, const octave_value& for_bounds);
+    jit_info (tree_evaluator& tr_eval, tree& tee,
+              const octave_value& for_bounds);
 
-    jit_info (tree_simple_for_command& tee, const octave_value& for_bounds);
+    jit_info (tree_evaluator& tr_eval, tree_simple_for_command& tee,
+              const octave_value& for_bounds);
 
     bool execute (const vmap& extra_vars = vmap ()) const;
 
     bool match (const vmap& extra_vars = vmap ()) const;
 
   private:
-
     typedef jit_convert::type_bound type_bound;
     typedef jit_convert::type_bound_vector type_bound_vector;
-    typedef void (*jited_function)(octave_base_value**);
+    typedef void (*jited_function) (octave_base_value **);
 
     void compile (tree& tee, jit_type *for_bounds = 0);
 
     octave_value find (const vmap& extra_vars, const std::string& vname) const;
 
+    tree_evaluator& m_tr_eval;
+
     // LLVM function associated to this jit_info object
     std::string m_llvm_function_name;
     jited_function m_function;
@@ -615,13 +653,10 @@
     type_bound_vector m_bounds;
   };
 
-
-  class
-  jit_function_info : public jit_module
+  class jit_function_info : public jit_module
   {
   public:
-
-    jit_function_info (octave_user_function& fcn,
+    jit_function_info (tree_evaluator& tr_eval, octave_user_function& fcn,
                        const octave_value_list& ov_args);
 
     bool execute (const octave_value_list& ov_args,
@@ -630,8 +665,9 @@
     bool match (const octave_value_list& ov_args) const;
 
   private:
+    typedef octave_base_value *(*jited_function) (octave_base_value **);
 
-    typedef octave_base_value *(*jited_function)(octave_base_value**);
+    tree_evaluator& m_tr_eval;
 
     // LLVM function associated to this jit_info object
     std::string m_llvm_function_name;
diff -r df9e3cb79379 -r 1ccb99c08f27 m4/acinclude.m4
--- a/m4/acinclude.m4	Wed May 08 18:45:34 2019 -0700
+++ b/m4/acinclude.m4	Fri May 31 16:09:22 2019 -0500
@@ -2884,7 +2884,7 @@
 ])
 dnl
 dnl Check llvm::IRBuilder::CreateConstInBoundsGEP1_32 API
-dbl
+dnl
 AC_DEFUN([OCTAVE_LLVM_IRBUILDER_CREATECONSTINBOUNDSGEP1_32_API], [
   AC_CACHE_CHECK([if llvm::IRBuilder::CreateConstInBoundsGEP1_32 requires a type argument],
     [octave_cv_llvm_irbuilder_createconstinboundsgep1_32_requires_type],
@@ -2914,6 +2914,56 @@
   fi
 ])
 dnl
+dnl Check llvm::WriteBitcodeToFile API
+dnl
+AC_DEFUN([OCTAVE_LLVM_WRITEBITCODETOFILE_API], [
+  AC_CACHE_CHECK([if llvm::WriteBitcodeToFile requires a pointer or a reference argument],
+    [octave_cv_llvm_writebitcodetofile_has_ptr_arg],
+    [AC_LANG_PUSH(C++)
+      AC_COMPILE_IFELSE(
+        [AC_LANG_PROGRAM([[
+#if defined (HAVE_LLVM_BITCODE_READERWRITER_H)
+#  include <llvm/Bitcode/ReaderWriter.h>
+#else
+#  include <llvm/Bitcode/BitcodeWriter.h>
+#endif
+#if defined (HAVE_LLVM_IR_FUNCTION_H)
+#  include <llvm/IR/LLVMContext.h>
+#  include <llvm/IR/Module.h>
+#else
+#  include <llvm/LLVMContext.h>
+#  include <llvm/Module.h>
+#endif
+#include <llvm/Support/FileSystem.h>
+#include <llvm/Support/raw_ostream.h>
+          ]], [[
+          std::error_code ec;
+          llvm::LLVMContext c;
+          llvm::Module* m = new llvm::Module ("test", c);
+          llvm::raw_fd_ostream fout ("test.bc", ec, llvm::sys::fs::F_None);
+          llvm::WriteBitcodeToFile (m, fout);
+        ]])],
+        octave_cv_llvm_writebitcodetofile_has_ptr_arg=pointer,
+        octave_cv_llvm_writebitcodetofile_has_ptr_arg=reference)
+    AC_LANG_POP(C++)
+  ])
+  if test $octave_cv_llvm_writebitcodetofile_has_ptr_arg = pointer; then
+    AC_DEFINE(LLVM_WRITEBITCODETOFILE_HAS_PTR_ARG, 1,
+      [Define to 1 if llvm::WriteBitcodeToFile requires a pointer argument.])
+  fi
+])
+dnl
+dnl OCTAVE_CHECK_SEARCH_PATH
+dnl
+dnl Check if the specified path is already in the system search path
+dnl used by $CXX using a regex match. Executes the second argument if
+dnl a match is found. Otherwise, the third argument is executed.
+AC_DEFUN([OCTAVE_CHECK_SEARCH_PATH], [
+  AS_IF([eval "$CXX -E -Wp,-v -xc++ /dev/null 2>&1 | grep -q \"^\\s*[$1][$]\""],
+        ifelse([$2], , , [$2]),
+        ifelse([$3], , , [$3]))
+])
+dnl
 dnl OCTAVE_CHECK_FORTRAN_SYMBOL_AND_CALLING_CONVENTIONS
 dnl
 dnl Set variables related to Fortran symbol names (append underscore,
